Subject: Re: [PATCH net-next v3 2/2] bnxt_en: implement netdev_queue_mgmt_ops

From: Jakub Kicinski <[email-masked]>
Date: Mon, 24 Jun 2024 15:02:54 -0700

On Mon, 24 Jun 2024 11:20:59 -0700 David Wei wrote:
> > What's the warning you hit?
> > We should probably bring back page_pool_unlink_napi(), 
> > if this is really needed.  
> 
> This one:
> 
> https://elixir.bootlin.com/linux/v6.10-rc5/source/net/core/page_pool.c#L1030
> 
> The cause is having two different bnxt_rx_ring_info referring to the
> same NAPI instance. One is the proper one in bp->rx_ring, the other is
> the temporarily allocated one for holding the "replacement" during the
> reset.

Makes sense, as I said please look thru the history - some form of
page_pool_unlink_napi() used to be exported for this use case, but
Olek(?) deleted it due to lack of in-tree users.

With that helper in place you can unlink the page pool while the NAPI
is stopped, without poking into internals at the driver level.